import os,sys,subprocess,math;
from compilelib import *;
import shutil;
from distutils.dir_util import copy_tree as copy_tree; #this version does overwrites

libname = "amsmathutil2.linux64"
targetname = "main_test";

kwargs = dict();

include = "-I./include";
include = include + " -I../../include_linux64";
kwargs['include'] = include;
kwargs['flags'] = "-fPIC";
kwargs['libdir'] = "-L./bin_linux64 -L../../lib_linux64";
#-lglew32-static
#lGL - only on linux
#lopengl32 on windows
#Note - glew binaries apparently only work with VisualC++ for windows... Must compile my own
#-lSDL2main  required for whatever macros end up transforming main() into WinMain()
#kwargs['libflags'] = "-lSDL2_tests.mingw64 -lamsstring.mingw64 -lmingw32 -lopengl32 -lglu32 -lglew32.dll -lSDL2main -lSDL2_image.dll -lSDL2.dll";
kwargs['libflags'] = "-l{}".format(libname);
#-Wl,-subsystem,windows
kwargs['linkerflags'] = "-static -static-libgcc -Wl,-rpath=."
kwargs['recurse'] = True;

#1: Pull required binary dynamic libraries to the bin folder
#I'm pretty sure libamslapack is not strongly coupled to anything in this lib.
#I'm including it anyway for further development later.
#shutil.copy('../../lib_winx64/libamsimg.dll.a','./bin_winx64');
#shutil.copy('../../lib_winx64/libamsimg.dll','./bin_winx64');
#shutil.copy('../../lib_winx64/glew32.dll','./bin_winx64');

#2: Pull updated versions of all include files to the include folder
#copy_tree('../../include_winx64/amsmath','./include/amsmath');

f1 = ['./src/main_test.cpp'];
f2 = replaceexts(f1,'.o');

#3: Compile any test programs
#x86_64-w64-mingw32-g++
gs_compile_list('g++',f1,**kwargs);
gs_link_list('g++',list_to_sss(f2),'./bin_linux64/'+targetname,**kwargs);
