#ifndef __AMSBOX2D_HPP__
#define __AMSBOX2D_HPP__

namespace ams
{

  class box2d
  {
  public:
    double xmin[2];
    double xmax[2];

    box2d();
    ~box2d();
    box2d& operator=(const box2d& other);
    box2d(const box2d& other);

    void setlimits(ams::vect2 pt1, ams::vect2 pt2);


    bool iswithin(ams::vect2 pt);
    double distance(ams::vect2 pt);
    bool iswithin(double x, double y);
    double distance(double x, double y);

  };


}


#endif
