#ifndef __AMSBOX3D_HPP__
#define __AMSBOX3D_HPP__

namespace ams
{


class box3d
{
public:
  double xmin[3];
  double xmax[3];

  box3d();
  ~box3d();
  box3d& operator=(const box3d& other);
  box3d(const box3d& other);

  void setlimits(ams::vect3 pt1, ams::vect3 pt2);
  bool iswithin(ams::vect3 pt);
  double distance(ams::vect3 pt);
  bool iswithin(double x, double y, double z);
  double distance(double x, double y, double z);

};


}


#endif
