#ifndef __AMS_TEMPLATEUTILS_HPP__
#define __AMS_TEMPLATEUTILS_HPP__

namespace ams
{

  //template min: returns lesser of two variables a and b
  //requires assignment and comparator operators to be defined for the object type
  template<typename T> T min(T a1, T a2)
  {
    T ret;
    if(a1<a2)
    {
      ret = a1;
    }
    else
    {
      ret = a2;
    }
    return ret;
  }

  //template max: returns greater of two variables a and b
  //requires assignment and comparator operators to be defined for the object type
  template<typename T> T max(T a1, T a2)
  {
    T ret;
    if(a1>a2)
    {
      ret = a1;
    }
    else
    {
      ret = a2;
    }
    return ret;
  }



}

#endif
